//: C01:Rawp.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Holé ukazatele.
#include <iostream>
#include <cstddef>
using namespace std;

class Kocka {
public:
  Kocka() { cout << "Kocka()" << endl; }
  ~Kocka() { cout << "~Kocka()" << endl; }
};

class Pes {
public:
  void* operator new(size_t sz) {
    cout << "vyhrazuje se Pes" << endl;
    throw 47;
  }
  void operator delete(void* p) {
    cout << "uvolňuje se Pes" << endl;
    ::operator delete(p);
  }
};

class PouzijZdroje {
  Kocka* bp;
  Pes* op;
public:
  PouzijZdroje(int pocet = 1) {
    cout << "PouzijZdroje()" << endl;
    bp = new Kocka[pocet];
    op = new Pes;
  }
  ~PouzijZdroje() {
    cout << "~PouzijZdroje()" << endl;
    delete [] bp; // smazani pole
    delete op;
  }
};

int main() {
  try {
    PouzijZdroje ur(3);
  } catch(int) {
    cout << "uvnitř správce" << endl;
  }
} ///:~
